From c1b77d5dcb6445d491980b639f488ceb42fcda89 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 27 2017 16:25:38 +0000
Subject: [PATCH 890/1001] Cache the list of owned packages


---

diff --git a/check-cache-coverage.py b/check-cache-coverage.py
index 409eafe..4e623cc 100755
--- a/check-cache-coverage.py
+++ b/check-cache-coverage.py
@@ -19,7 +19,6 @@ import sys
 
 import hubs.app
 import hubs.widgets
-import hubs.widgets.caching
 import hubs.models
 
 
diff --git a/hubs/tests/test_widget_caching.py b/hubs/tests/test_widget_caching.py
index c04ba76..2a2684f 100644
--- a/hubs/tests/test_widget_caching.py
+++ b/hubs/tests/test_widget_caching.py
@@ -1,6 +1,7 @@
 from __future__ import unicode_literals
 
-from hubs.widgets.caching import cache, CachedFunction
+from hubs.utils.cache import cache
+from hubs.widgets.caching import CachedFunction
 
 from mock import Mock
 from hubs.tests import APPTest
diff --git a/hubs/utils/cache.py b/hubs/utils/cache.py
new file mode 100644
index 0000000..ab618a2
--- /dev/null
+++ b/hubs/utils/cache.py
@@ -0,0 +1,30 @@
+"""
+Attributes:
+    cache (dogpile.cache.region.CacheRegion): The cache where data
+        will be stored. It is configured with the ``fedora-hubs.cache`` key in
+        fedmsg configuration.
+"""
+
+from __future__ import unicode_literals
+
+import dogpile
+import dogpile.cache
+
+from hubs.utils import get_fedmsg_config
+
+
+def _get_cache():
+    cache_defaults = {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": 1,  # Expire every 1 second, for development
+        "arguments": {
+            "filename": "/var/tmp/fedora-hubs-cache.db",
+        },
+    }
+    cache = dogpile.cache.make_region()
+    fedmsg_config = get_fedmsg_config()
+    cache.configure(**fedmsg_config.get('fedora-hubs.cache', cache_defaults))
+    return cache
+
+
+cache = _get_cache()
diff --git a/hubs/utils/pkgdb.py b/hubs/utils/pkgdb.py
new file mode 100644
index 0000000..55be246
--- /dev/null
+++ b/hubs/utils/pkgdb.py
@@ -0,0 +1,45 @@
+from __future__ import unicode_literals
+
+import logging
+
+import requests
+
+from .cache import cache
+
+log = logging.getLogger(__name__)
+
+PKGDB_URL = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
+
+
+def get_owned_packages(username, use_cache=True):
+    """Get the list of packages owned by the username.
+
+    Args:
+        username (str): The FAS username.
+        use_cache (bool): Whether to cache the results for a few minutes.
+            Defaults to ``True``.
+    """
+    def get_data():
+        url = "/".join([PKGDB_URL, username])
+        try:
+            response = requests.get(url, timeout=5)
+        except (requests.exceptions.ConnectionError,
+                requests.exceptions.Timeout):
+            log.warning("Could not get the list of owned packages for %s",
+                        username)
+            return []
+        try:
+            data = response.json()
+        except ValueError:
+            log.warning(
+                "Invalid JSON response getting the list of packages "
+                "owned by %s: %s", username, response.text)
+            return []
+        owned = data['point of contact'] + data['co-maintained']
+        return sorted(set(p['name'] for p in owned))
+    if not use_cache:
+        return get_data()
+    else:
+        cache_key = ":".join(["owned_packages", username])
+        # Cache for 5 minutes, it seems reasonable.
+        return cache.get_or_create(cache_key.encode("utf-8"), get_data, 5 * 60)
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index ae09257..7125aaf 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -1,14 +1,13 @@
 from __future__ import unicode_literals
 
 import logging
-import json
 
-import requests
 import pkgwat.api
 
+from hubs.utils.pkgdb import get_owned_packages
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
-from hubs.widgets.caching import CachedFunction, cache
+from hubs.widgets.caching import CachedFunction
 
 
 log = logging.getLogger('hubs.widgets')
@@ -47,24 +46,20 @@ class BaseView(WidgetView):
 
 
 class GetIssues(CachedFunction):
+    """Returns data for Bugzilla widget.
 
-    ''' Returns data for Bugzilla Widget. Queries pkgdb api for package
-    list of the user and bugzilla for correspoding issues '''
+    Queries pkgdb api for package list of the user and bugzilla for
+    corresponding issues.
+    """
 
     def execute(self):
         username = self.instance.config["username"]
-        url = "/".join([PKGDB_URL, username])
-        response = requests.get(url)
-        data = response.json()
-
+        owned = get_owned_packages(username)
         issues = []
-
-        # get the packages of which the user is
-        # point of contact
-        for package in data["point of contact"]:
+        for pkg_name in owned:
             if len(issues) == 3:
                 break
-            pkg_details = pkgwat.api.bugs(package['name'])
+            pkg_details = pkgwat.api.bugs(pkg_name)
             for row in pkg_details['rows']:
                 if len(issues) == 3:
                     break
@@ -72,59 +67,16 @@ class GetIssues(CachedFunction):
                     dict(
                         id=row['id'],
                         title=row['description'],
-                        pkg_name=package['name'],
+                        pkg_name=pkg_name,
                     )
                 )
-
-        # get the packages of which the user is
-        # co maintainer
-        for package in data["co-maintained"]:
-            if len(issues) == 3:
-                break
-            pkg_details = pkgwat.api.bugs(package['name'])
-            for row in pkg_details['rows']:
-                if len(issues) == 3:
-                    break
-                issues.append(
-                    dict(
-                        id=row['id'],
-                        title=row['description'],
-                        pkg_name=package['name'],
-                    )
-                )
-
         return issues
 
     def should_invalidate(self, message):
-        if "bug" not in message["msg"]:
-            return False
         try:
             component = message['msg']['bug']['component']
         except KeyError:
             return False
         username = self.instance.config["username"]
-
-        # Cache for a while the list of packages owned by the user, the HTTP
-        # request is waaaay too long to be run on each incoming bug message.
-        def get_owned():
-            url = "/".join([PKGDB_URL, username])
-            try:
-                response = requests.get(url, timeout=5)
-            except (requests.exceptions.ConnectionError,
-                    requests.exceptions.Timeout):
-                log.warning("Could not get the list of owned packages for %s",
-                            username)
-                return []
-            try:
-                data = response.json()
-            except json.decoder.JSONDecodeError:
-                log.warning(
-                    "Invalid JSON response getting the list of packages "
-                    "owned by %s: %s", username, response.text)
-                return []
-            owned = data['point of contact'] + data['co-maintained']
-            return [p['name'] for p in owned]
-        owned_cache_key = ":".join(["owned_packages", username])
-        # Cache for 5 minutes, it seems reasonable.
-        owned = cache.get_or_create(owned_cache_key, get_owned, 5 * 60)
+        owned = get_owned_packages(username)
         return (component in owned)
diff --git a/hubs/widgets/caching.py b/hubs/widgets/caching.py
index 51c46b5..02abde3 100644
--- a/hubs/widgets/caching.py
+++ b/hubs/widgets/caching.py
@@ -1,36 +1,14 @@
-"""
-Attributes:
-    cache (dogpile.cache.region.CacheRegion): The cache where function results
-        will be stored. It is configured with the ``fedora-hubs.cache`` key in
-        fedmsg configuration.
-"""
 from __future__ import unicode_literals
 
 import datetime
-import dogpile.cache
 import logging
 
-from hubs.utils import get_fedmsg_config
-
-
-log = logging.getLogger(__name__)
-
+import dogpile.cache
 
-def _get_cache():
-    cache_defaults = {
-        "backend": "dogpile.cache.dbm",
-        "expiration_time": 1,  # Expire every 1 second, for development
-        "arguments": {
-            "filename": "/var/tmp/fedora-hubs-cache.db",
-        },
-    }
-    cache = dogpile.cache.make_region()
-    fedmsg_config = get_fedmsg_config()
-    cache.configure(**fedmsg_config.get('fedora-hubs.cache', cache_defaults))
-    return cache
+from hubs.utils.cache import cache
 
 
-cache = _get_cache()
+log = logging.getLogger(__name__)
 
 
 class CachedFunction(object):
diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index 4339c04..75b4487 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -15,7 +15,7 @@ import argparse
 import hubs.app
 import hubs.models
 import hubs.widgets.base
-import hubs.widgets.caching
+
 
 # get the DB session
 session = hubs.app.session

